<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_practice_widget".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPracticeWidget".
 *
 * Columns in table "provider_practice_widget" available as properties of the model,
 * followed by relations of table "provider_practice_widget" available as properties of the model.
 *
 * @property integer $id
 * @property integer $widget_id
 * @property integer $provider_id
 * @property integer $practice_id
 * @property integer $prefix
 * @property integer $suffix
 *
 * @property Provider $provider
 * @property Practice $practice
 * @property Widget $widget
 */
abstract class BaseProviderPracticeWidget extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_practice_widget';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPracticeWidget|ProviderPracticeWidgets', $n);
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('widget_id', 'required'),
            array('widget_id, provider_id, practice_id, prefix, suffix', 'numerical', 'integerOnly' => true),
            array('provider_id, practice_id, prefix, suffix, middle_name', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, widget_id, provider_id, practice_id, prefix, suffix', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'widget' => array(self::BELONGS_TO, 'Widget', 'widget_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'widget_id' => null,
            'provider_id' => null,
            'practice_id' => null,
            'provider' => null,
            'practice' => null,
            'prefix' => null,
            'suffix' => null,
            'middle_name' => null,
            'widget' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('widget_id', $this->widget_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('prefix', $this->prefix);
        $criteria->compare('suffix', $this->suffix);
        $criteria->compare('middle_name', $this->middle_name);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
